.const
comment 
-----------------------------------------------------
Only eax and the flags are changed by the functions
no use of the fpu or sse intructions are made

Starting the timer:
invoke StartTimer,Number_of_loop,unit,priority
	*Number_of_loop can be 1 to x(dword)
	*unit can be one of the constants defined below
	*priority can be null or one of the values defined for SetPriorityClass
EndTimer:
no parameter,return a pointer on TIMER_RESULT struct
The structure give a result in periods or in seconds/unit
frequency = Number of periods per second

---------- --------- ------------ ------------
invoke StartTimer,Nbloop,unite_microseconde,NULL
.....
invoke EndTimer
	mov edx,dword ptr [eax].TIMER_RESULT.periode[0]
---------------------------------------------------------

StartTimer PROTO  :DWORD,  :DWORD,  :DWORD 
EndTimer PROTO 
unite_seconde	equ 1
unite_milliseconde equ 1000
unite_microseconde equ 1000000
BLELOWORD  equ     [0]
BLEHIWORD  equ     [4]	
TIMER_RESULT STRUCT
	periode  dq ?
	fseconde dq ?
TIMER_RESULT ENDS
;Rsolution minimale de QueryPerformanceCounter: 1/1193182 s = 0.84 s
.data
	align 8	
	__timer__pc__frequency__    dq 0
	__timer__pc__count__start   dq 0
	__timer__pc__count__end     dq 0
	;----------- ne pas dplacer ----------
	Number_Periodes   dq 0			;1/frequency
	exetime_in_unite	dq 0
	overhead 		dq 0
	;----------------------------------------
	__timer__loop__counter__    dd 0	
	mille dq 0
	mem_priority 			dd 0
	return_adresse 			dd 0
.code
	
	

;################################################################
StartTimer PROC  boucle:DWORD, unite:DWORD ,priority:DWORD
	;recupere l'adresse de retour
	;pas de parametres
	mov eax,[esp+4]
	mov return_adresse,eax	
	;----------------------------
	pushad
	mov eax,unite
	mov dword ptr mille[0],eax	
	.if boucle == 0
		jmp  FindeStartTimer
	.else
		mov eax,boucle
		mov __timer__loop__counter__,eax
	.endif
	.if priority != 0
		invoke GetCurrentProcess
		push eax
		invoke GetPriorityClass,eax
		mov mem_priority,eax		
		pop eax
		invoke SetPriorityClass, eax, priority	
	.endif	
	invoke QueryPerformanceFrequency, ADDR __timer__pc__frequency__
	.IF eax != 0
		;overhead,time to execute function QueryPerformanceCounter
		invoke QueryPerformanceCounter, ADDR __timer__pc__count__start
		invoke QueryPerformanceCounter, ADDR __timer__pc__count__end
		mov   eax,DWORD PTR __timer__pc__count__end[0]
		sub   eax,DWORD PTR __timer__pc__count__start[0]
		mov   ecx,DWORD PTR __timer__pc__count__end[+4]
		sbb   ecx,DWORD PTR __timer__pc__count__start[+4]
		mov	DWORD PTR overhead[0],eax
		mov   DWORD PTR overhead[4],ecx
		;start count
		invoke QueryPerformanceCounter, ADDR __timer__pc__count__start			
	.else
		jmp FindeStartTimer
	.endif	
 FindeStartTimer:
	popad		;---- a ajout au temps -----
         ret
StartTimer endp

;################################################################

EndTimer PROC 
	.if dword ptr mille[0] == 0 || __timer__loop__counter__ == 0
		jmp FindeEndTimer
	.endif
	dec __timer__loop__counter__
	jz @F
	;retablir pile
	add esp,4
	jmp dword ptr return_adresse
	@@:
	pushad
	invoke QueryPerformanceCounter, ADDR __timer__pc__count__end
	;faire la soustraction des deux qword
	;c++ traduction
	mov   eax,DWORD PTR __timer__pc__count__end[0]
	sub   eax,DWORD PTR __timer__pc__count__start[0]
	mov   ecx,DWORD PTR __timer__pc__count__end[+4]
	sbb   ecx,DWORD PTR __timer__pc__count__start[+4]
	mov	DWORD PTR Number_Periodes[0],eax
	mov   DWORD PTR Number_Periodes[4],ecx
	;enlever overhead	
	mov   eax,DWORD PTR Number_Periodes[0]
	sub   eax,DWORD PTR overhead[0]
	mov   ecx,DWORD PTR Number_Periodes[+4]
	sbb   ecx,DWORD PTR overhead[+4]
	mov	DWORD PTR Number_Periodes[0],eax
	mov   DWORD PTR Number_Periodes[4],ecx	
	
	;-----------------------------------------------
	;double exeTime_in_ms = (double)diffCount * 1000.0 / freq;	
	push dword ptr mille[4]
	push dword ptr mille[0]
	push dword ptr Number_Periodes[4]
	push dword ptr Number_Periodes[0]
	call _allmul
	mov 	dword ptr exetime_in_unite[0],eax
	mov 	dword ptr exetime_in_unite[4],edx
	push dword ptr __timer__pc__frequency__[4]
	push dword ptr __timer__pc__frequency__[0]
	push dword ptr exetime_in_unite[4]
	push dword ptr exetime_in_unite[0]	
	call 	aulldiv
	mov dword ptr exetime_in_unite[0],eax
	mov dword ptr exetime_in_unite[4],edx
	.if mem_priority != 0
		invoke GetCurrentProcess
		invoke SetPriorityClass, eax, mem_priority
		mov mem_priority,0			
	.endif
	mov dword ptr mille[0],0
	popad
	lea eax,Number_Periodes

 FindeEndTimer:
         ret
EndTimer endp

;################################################################


_allmul PROC NEAR
.FPO (0, 4, 0, 0, 0, 0)

A       EQU     [esp + 4]       ; stack address of a
B       EQU     [esp + 12]      ; stack address of b

;
;       AHI, BHI : upper 32 bits of A and B
;       ALO, BLO : lower 32 bits of A and B
;
;             ALO * BLO
;       ALO * BHI
; +     BLO * AHI
; ---------------------
;

        mov     eax,BLEHIWORD(A)
        mov     ecx,BLEHIWORD(B)
        or      ecx,eax         ;test for both hiwords zero.
        mov     ecx,BLELOWORD(B)
        jnz     short hard      ;both are zero, just mult ALO and BLO

        mov     eax,BLELOWORD(A)
        mul     ecx

        ret     16              ; callee restores the stack

hard:
        push    ebx
.FPO (1, 4, 0, 0, 0, 0)

; must redefine A and B since esp has been altered

A2      EQU     [esp + 8]       ; stack address of a
B2      EQU     [esp + 16]      ; stack address of b

        mul     ecx             ;eax has AHI, ecx has BLO, so AHI * BLO
        mov     ebx,eax         ;save result

        mov     eax,BLELOWORD(A2)
        mul     dword ptr BLEHIWORD(B2) ;ALO * BHI
        add     ebx,eax         ;ebx = ((ALO * BHI) + (AHI * BLO))

        mov     eax,BLELOWORD(A2)  ;ecx = BLO
        mul     ecx             ;so edx:eax = ALO*BLO
        add     edx,ebx         ;now edx has all the LO*HI stuff

        pop     ebx

        ret     16              ; callee restores the stack

_allmul ENDP



;--------------------------------------------------------------------
	
;***
;ulldiv.asm - unsigned long divide routine
;
;       Copyright (c) Microsoft Corporation. All rights reserved.
;
;Purpose:
;       defines the unsigned long divide routine
;           _aulldiv
;
;*******************************************************************************


;***
;ulldiv - unsigned long divide
;
;Purpose:
;       Does a unsigned long divide of the arguments.  Arguments are
;       not changed.
;
;Entry:
;       Arguments are passed on the stack:
;               1st pushed: divisor (QWORD)
;               2nd pushed: dividend (QWORD)
;
;Exit:
;       EDX:EAX contains the quotient (dividend/divisor)
;       NOTE: this routine removes the parameters from the stack.
;
;Uses:
;       ECX
;
;Exceptions:
;
;*******************************************************************************

.code
aulldiv        PROC NEAR
.FPO (2, 4, 0, 0, 0, 0)

        push    ebx
        push    esi

; Set up the local stack and save the index registers.  When this is done
; the stack frame will look as follows (assuming that the expression a/b will
; generate a call to uldiv(a, b)):
;
;               -----------------
;               |               |
;               |---------------|
;               |               |
;               |--divisor (b)--|
;               |               |
;               |---------------|
;               |               |
;               |--dividend (a)-|
;               |               |
;               |---------------|
;               | return addr** |
;               |---------------|
;               |      EBX      |
;               |---------------|
;       ESP---->|      ESI      |
;               -----------------
;

DVND    equ     [esp + 12]      ; stack address of dividend (a)
DVSR    equ     [esp + 20]      ; stack address of divisor (b)

;
; Now do the divide.  First look to see if the divisor is less than 4194304K.
; If so, then we can use a simple algorithm with word divides, otherwise
; things get a little more complex.
;

        mov     eax,BLEHIWORD(DVSR) ; check to see if divisor < 4194304K
        or      eax,eax
        jnz     short L1        ; nope, gotta do this the hard way
        mov     ecx,BLELOWORD(DVSR) ; load divisor
        mov     eax,BLEHIWORD(DVND) ; load high word of dividend
        xor     edx,edx
        div     ecx             ; get high order bits of quotient
        mov     ebx,eax         ; save high bits of quotient
        mov     eax,BLELOWORD(DVND) ; edx:eax <- remainder:lo word of dividend
        div     ecx             ; get low order bits of quotient
        mov     edx,ebx         ; edx:eax <- quotient hi:quotient lo
        jmp     short L2        ; restore stack and return

;
; Here we do it the hard way.  Remember, eax contains DVSRHI
;

L1:
        mov     ecx,eax         ; ecx:ebx <- divisor
        mov     ebx,BLELOWORD(DVSR)
        mov     edx,BLEHIWORD(DVND) ; edx:eax <- dividend
        mov     eax,BLELOWORD(DVND)
L3:
        shr     ecx,1           ; shift divisor right one bit; hi bit <- 0
        rcr     ebx,1
        shr     edx,1           ; shift dividend right one bit; hi bit <- 0
        rcr     eax,1
        or      ecx,ecx
        jnz     short L3        ; loop until divisor < 4194304K
        div     ebx             ; now divide, ignore remainder
        mov     esi,eax         ; save quotient

;
; We may be off by one, so to check, we will multiply the quotient
; by the divisor and check the result against the orignal dividend
; Note that we must also check for overflow, which can occur if the
; dividend is close to 2**64 and the quotient is off by 1.
;

        mul     dword ptr BLEHIWORD(DVSR) ; QUOT * BLEHIWORD(DVSR)
        mov     ecx,eax
        mov     eax,BLELOWORD(DVSR)
        mul     esi             ; QUOT * BLELOWORD(DVSR)
        add     edx,ecx         ; EDX:EAX = QUOT * DVSR
        jc      short L4        ; carry means Quotient is off by 1

;
; do long compare here between original dividend and the result of the
; multiply in edx:eax.  If original is larger or equal, we are ok, otherwise
; subtract one (1) from the quotient.
;

        cmp     edx,BLEHIWORD(DVND) ; compare hi words of result and original
        ja      short L4        ; if result > original, do subtract
        jb      short L5        ; if result < original, we are ok
        cmp     eax,BLELOWORD(DVND) ; hi words are equal, compare lo words
        jbe     short L5        ; if less or equal we are ok, else subtract
L4:
        dec     esi             ; subtract 1 from quotient
L5:
        xor     edx,edx         ; edx:eax <- quotient
        mov     eax,esi

;
; Just the cleanup left to do.  edx:eax contains the quotient.
; Restore the saved registers and return.
;

L2:

        pop     esi
        pop     ebx

        ret     16

aulldiv        ENDP
;---------------------------------------------------------------------------------------------



